<?php
/*
Plugin Name: Paginator
Plugin URI: http://dzhus.com/development/paginator/
Description: Adds "paginator3000" paging navigation to your WordPress blog.
Version: 0.2.4
Author: dzhus
Author URI: http://blog.dzhus.com
*/


/*  
    Copyright 2008  Olzhas Murtazin  (email : dzhusi@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

# Function: Paginator Option Menu
add_action('admin_menu', 'paginator_menu');
function paginator_menu() {
	if (function_exists('add_options_page')) {
		add_options_page(__('Paginator', 'paginator'), __('Paginator', 'paginator'), 'manage_options', 'paginator/options.php') ;
	}
}

# Function: Paginator skin and javascript
add_action('wp_head', 'paginator_sources');
function paginator_sources() {
	echo "\n".'<!-- Start Of Script Generated By Paginator 0.2.4 -->'."\n";
	if(@file_exists(TEMPLATEPATH.'/paginator3000.css')) {
		echo '<link rel="stylesheet" href="'.get_stylesheet_directory_uri().'/paginator3000.css" type="text/css" media="screen" />'."\n";	
	} else {
		echo '<link rel="stylesheet" href="'.get_option('siteurl').'/wp-content/plugins/paginator/skin/paginator3000.css" type="text/css" media="screen" />'."\n";
	}	
	echo('<script type="text/javascript" src="'.get_option('siteurl').'/wp-content/plugins/paginator/js/paginator3000.js" ></script>'."\n"); 
	echo '<!-- End Of Script Generated By Paginator 0.2.4 -->'."\n";
}

function get_pagenum_link_without_queries() {
	global $wp_rewrite;

	$request = remove_query_arg( 'paged' );

	$home_root = parse_url(get_option('home'));
	$home_root = ( isset($home_root['path']) ) ? $home_root['path'] : '';
	$home_root = preg_quote( trailingslashit( $home_root ), '|' );

	$request = preg_replace('|^'. $home_root . '|', '', $request);
	$request = preg_replace('|^/+|', '', $request);

	if ( !$wp_rewrite->using_permalinks() || is_admin() ) {
		$base = trailingslashit( get_bloginfo( 'home' ) );
		$result = add_query_arg( 'paged', '=', $base . $request);
		$result = apply_filters('get_pagenum_link', $result);
	} else {
		$qs_regex = '|\?.*?$|';
		preg_match( $qs_regex, $request, $qs_match );

		if ( !empty( $qs_match[0] ) ) {
			$request = preg_replace( $qs_regex, '', $request );
		}

		$request = preg_replace( '|page/\d+/?$|', '', $request);
		$request = preg_replace( '|^index\.php|', '', $request);
		$request = ltrim($request, '/');

		$base = trailingslashit( get_bloginfo( 'url' ) );

		if ( $wp_rewrite->using_index_permalinks())
			$base .= 'index.php/';
		
		$request = ( ( !empty( $request ) ) ? trailingslashit( $request ) : $request ) . user_trailingslashit( 'page/' , 'paged' );

		$result = $base . $request ;
		$result = apply_filters('get_pagenum_link', $result);
		
		if ($result[strlen($result)-1]!="/")  
			$result = $result . '/';
	}
	
	return $result;
}

function get_pagenum_link_query() {
	global $wp_rewrite;

	$request = remove_query_arg( 'paged' );
	$home_root = parse_url(get_option('home'));
	$home_root = ( isset($home_root['path']) ) ? $home_root['path'] : '';
	$home_root = preg_quote( trailingslashit( $home_root ), '|' );
	$request = preg_replace('|^'. $home_root . '|', '', $request);
	$request = preg_replace('|^/+|', '', $request);

	if ( $wp_rewrite->using_permalinks() && !is_admin() ) {
		$qs_regex = '|\?.*?$|';
		preg_match( $qs_regex, $request, $qs_match );

		if ( !empty( $qs_match[0] ) ) {
			$query_string = $qs_match[0];

		} else {
			$query_string = '';
		}

		$result = $query_string ;
	}

	$result = apply_filters('get_pagenum_link', $result);

	return $result;
}

# Function: Create Paginator
function wp_paginator() {
	global $wp_query;
	if (!is_single()) {
		$paged = intval(get_query_var('paged'));
		$cat = (intval(get_query_var('cat'))) ? ('cat='. intval(get_query_var('cat')) . '&') : '';
		$paginator_options = get_option('paginator_options');
		$max_page = $wp_query->max_num_pages;
		$pages_to_show = intval($paginator_options['num_pages']);
		$display_total=intval($paginator_options['display_total']);
		$curr_url = clean_url(get_pagenum_link_without_queries());
		$curr_query = get_pagenum_link_query();
		
		if(empty($paged) || $paged == 0 || $paged < 0) {
			$paged = 1;
		}
		
		echo('<div class="paginator" id="paginator"></div>');
		
		if($display_total==1){
			echo('<div class="paginator_pages">'.$max_page.' pages</div>');
		}
		
		echo(
			
			'<script type="text/javascript">
				if(navigator.appName=="Microsoft Internet Explorer"){
					var prevonload=window.onload;
					if(typeof window.onload!="function"){
						window.onload=function(){
							pag = new Paginator("paginator",' . $wp_query->max_num_pages . ',' . $pages_to_show . ',' . $paged . ',"' . $curr_url . '","' . $curr_query . '");						}
					}else{
						window.onload=function(){
							prevonload();
							pag = new Paginator("paginator",' . $wp_query->max_num_pages . ',' . $pages_to_show . ',' . $paged . ',"' . $curr_url . '","' . $curr_query . '");
						}
					}
				}else{
					pag = new Paginator("paginator",' . $wp_query->max_num_pages . ',' . $pages_to_show . ',' . $paged . ',"' . $curr_url . '","' . $curr_query . '");
				}	
			</script>');
	}
}
?>